#! /usr/bin/perl -w

# WVC (Web Virus Count), v2.4, by Jean-Edouard BABIN (Jeb@jeb.com.fr)
$Version = 2.4;

# Version 2.4   : some misspelling corrected, page can be seen as an html table (see $html_table) and some minor change
# Version 2.3   : add /scripts/nsiislog.dll detection; code cleanup
# Version 2.2   : support check in rotated log file (gziped)
# Version 2.1.1 : print time taken to generate stats and date
# Version 2.1   : print % of requests by virus
# Version 2.0   : Now support Nimda detection
# Version 1.0   : initial release

$oldlog = 0; ## set to 0 to not check in rotated log file
             ## set to 1 to check for rotated log file

$file = "/usr/local/apache/logs/access_log";
## set this to you apache log file

$filer = "";
## set this only if you rotated log file are not in same location than $file
## example: /var/log/apache/rotated, if you rotated file are:
##    /var/log/apache/rotated.0.gz ,  /var/log/apache/rotated.1.gz ...

$html_table = 0; # do you want web page as a table or not ?

## End of config

print "Content-type: text/html\n\n";

$startat = time();
$date = scalar localtime;
$pourcent = 100;
$counter[1] = $counter[2] = $counter[3] = $counter[4] = $i = 0;

$filer = $file if ($filer eq "");

open (FILE, "$file") or die ("Cannot find $file!");
while (<FILE>)
{
        if ($_ =~ /default.ida/) {
		$counter[1]++ if ($_ =~ /default.ida\?NNN/);
		$counter[2]++ if ($_ =~ /default.ida\?XXX/);
        }
	$counter[3]++ if ($_ =~ /c\+dir/);
	$counter[4]++ if ($_ =~ m|/scripts/nsiislog.dll|);
	$i=$i+1;
}
close (FILE);

if ($oldlog eq 1) {
	foreach $filegz (glob "$filer*.gz") {
		open (FILE, "gzip -dc $filegz|") or die ("Cannot find $filegz!");
		while (<FILE>)
		{
			if ($_ =~ /default.ida/) {
				$counter[1]++ if ($_ =~ /default.ida\?NNN/);
				$counter[2]++ if ($_ =~ /default.ida\?XXX/);
			}
			$counter[3]++ if ($_ =~ /c\+dir/);
			$counter[4]++ if ($_ =~ m|/scripts/nsiislog.dll|);
			$i=$i+1;
		}
		close (FILE);
	}
}


for (0..$#counter) {
	$addcounter += $counter[$_];
}

for (0..$#counter) {
	$percentcounter[$_] = ($counter[$_]/$i)*$pourcent;
	$percentcounter[$_] =~ /(\d+)\.?(\d{0,3})/;
	if ($2) {
		$percentcounter[$_] = "$1.$2";
	} else {
		$percentcounter[$_] = "$1"
	}
}
$addpercentcounter = ($addcounter/$i)*$pourcent;
$addpercentcounter =~ /(\d+)\.?(\d{0,3})/;
if ($2) {
	$addpercentcounter = "$1.$2";
} else {
	$addpercentcounter = "$1"
}

print <<EOF;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<title>Apache Worm Hits</title>
    <style type="text/css">
<!-- a { font-family: Verdana, Arial, Helvetica, sans-serif; text-decoration: none } a:hover {  color: #EE0000} -->
</style>
</head>

<body bgcolor="#ffffff" text="#000000" link="#000099" vlink="#000099" alink="#880000">
<center><font face="arial" size="+3"  style="color: #000000">Apache Worm Hits<hr color="FF0000"></font><center>
EOF

if ($html_table) {
print<<EOF;
<br>
<table width="80%">
	<tr><td align="center"><b>Virus</b></td><td align="center"><b>Requests (%)</b></td></tr>
	<tr><td align="center"><font face="arial" size="+3" color="#FF0000">CodeRed</font></td><td align="center"><font face="arial" size="+11" color="#000000">$counter[1]</font> ($percentcounter[1]%)</td></tr>
	<tr><td align="center"><font face="arial" size="+3" color="#FF0000">CodeRed II</font></td><td align="center"><font face="arial" size="+11" color="#000000">$counter[2]</font> ($percentcounter[2]%)</td></tr>
	<tr><td align="center"><font face="arial" size="+3" color="#FF0000">Nimda</font></td><td align="center"><font face="arial" size="+11" color="#000000">$counter[3]</font> ($percentcounter[3]%)</td></tr>
	<tr><td align="center"><font face="arial" size="+3" color="#FF0000">nsiislog.dll</font></td><td align="center"><font face="arial" size="+11" color="#000000">$counter[4]</font> ($percentcounter[4]%)</td></tr>
</table>
EOF
}
else {
print<<EOF;
<font face="arial" size="+3" color="#FF0000">CodeRed</font><br><font face="arial" size="+11" color="#000000">$counter[1]</font><br> ($percentcounter[1]%)<br>
<font face="arial" size="+3" color="#FF0000">CodeRed II</font><br><font face="arial" size="+11" color="#000000">$counter[2]</font><br> ($percentcounter[2]%)<br>
<font face="arial" size="+3" color="#FF0000">Nimda</font><br><font face="arial" size="+11" color="#000000">$counter[3]</font><br> ($percentcounter[3]%)<br>
<font face="arial" size="+3" color="#FF0000">nsiislog.dll</font><br><font face="arial" size="+11" color="#000000">$counter[4]</font><br> ($percentcounter[4]%)<br>
EOF
}

print<<EOF;
<p align=left><font face="arial" size="+1">total of $i requests, $addpercentcounter% of virus</font></p></center>
EOF
$mtime = time();
$dif = $mtime - $startat;
print <<EOF;
<p align=right><font face="arial" size="+1">Statistics generated in $dif seconds at $date</font></p>
<hr color="FF0000"><center><a href="http://jeb.be/codingstuff/wvc.html">Page generated by Web Virus Count v$Version</a>
</center></body></html>
EOF
